Loading...
Searching...
No Matches
Sip_accept_encoding

## Macros

#define | sip_accept_encoding(sip)
| Access a SIP Accept-Encoding header structure sip_accept_encoding_t from sip_t.
#define | SIP_ACCEPT_ENCODING_INIT()
| Initializer for structure sip_accept_encoding_t.
#define | SIPTAG_ACCEPT_ENCODING(x)
| Tag list item for pointer to a Accept-Encoding header structure sip_accept_encoding_t.
#define | SIPTAG_ACCEPT_ENCODING_REF(x)
| Tag list item for reference to a Accept-Encoding header pointer.
#define | SIPTAG_ACCEPT_ENCODING_STR(s)
| Tag list item for string with Accept-Encoding header value.
#define | SIPTAG_ACCEPT_ENCODING_STR_REF(x)
| Tag list item for reference to a Accept-Encoding header string.

## Typedefs

typedef msg_accept_any_t | sip_accept_encoding_t
| @

## Functions

issize_t | sip_accept_encoding_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Accept-Encoding header.
issize_t | sip_accept_encoding_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Accept-Encoding header.
sip_accept_encoding_t * | sip_accept_encoding_init (sip_accept_encoding_t x[1])
| Initialize a structure sip_accept_encoding_t.
int | sip_is_accept_encoding (sip_header_t const *header)
| Test if header object is instance of sip_accept_encoding_t.
sip_accept_encoding_t * | sip_accept_encoding_dup (su_home_t *home, sip_accept_encoding_t const *hdr))
| Duplicate a list of Accept-Encoding header header structures sip_accept_encoding_t.
sip_accept_encoding_t * | sip_accept_encoding_copy (su_home_t *home, sip_accept_encoding_t const *hdr))
| Copy a list of Accept-Encoding header header structures sip_accept_encoding_t.
sip_accept_encoding_t * | sip_accept_encoding_make (su_home_t *home, char const *s))
| Make a Accept-Encoding header structure sip_accept_encoding_t.
sip_accept_encoding_t * | sip_accept_encoding_format (su_home_t *home, char const *fmt,...)))
| Make a Accept-Encoding header from formatting result.

## Variables

msg_hclass_t | sip_accept_encoding_class []
| Header class for Accept-Encoding header.
tag_typedef_t | siptag_accept_encoding
| Tag for Accept-Encoding header object.
tag_typedef_t | siptag_accept_encoding_str
| Tag for string with Accept-Encoding header value.

## Detailed Description

## Macro Definition Documentation

## SIP_ACCEPT_ENCODING_INIT

#define SIP_ACCEPT_ENCODING_INIT | ( |  | ) |

Initializer for structure sip_accept_encoding_t.

A static sip_accept_encoding_t structure for Accept-Encoding header must be initialized with the SIP_ACCEPT_ENCODING_INIT() macro. For instance,

sip_accept_encoding_t sip_accept_encoding = SIP_ACCEPT_ENCODING_INIT;
SIP_ACCEPT_ENCODING_INIT
#define SIP_ACCEPT_ENCODING_INIT()
Initializer for structure sip_accept_encoding_t.
Definition sip_protos.h:7288
sip_accept_encoding
#define sip_accept_encoding(sip)
Access a SIP Accept-Encoding header structure sip_accept_encoding_t from sip_t.
Definition sip_protos.h:7271
sip_accept_encoding_t
msg_accept_any_t sip_accept_encoding_t
@
Definition sip.h:140

## SIPTAG_ACCEPT_ENCODING

#define SIPTAG_ACCEPT_ENCODING | ( |  | x | ) |

Tag list item for pointer to a Accept-Encoding header structure sip_accept_encoding_t.

The SIPTAG_ACCEPT_ENCODING() macro is used to include a tag item with a pointer to a sip_accept_encoding_t structure in a tag list.

Parameters

  x | pointer to a sip_accept_encoding_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_ACCEPT_ENCODING_REF().

## SIPTAG_ACCEPT_ENCODING_STR

#define SIPTAG_ACCEPT_ENCODING_STR | ( |  | s | ) |

Tag list item for string with Accept-Encoding header value.

The SIPTAG_ACCEPT_ENCODING_STR() macro is used to include a tag item with a string containing value of a sip_accept_encoding_t header in a tag list.

Parameters

  s | pointer to a string containing Accept-Encoding header value, or NULL.

The string in SIPTAG_ACCEPT_ENCODING_STR() can be converted to a sip_accept_encoding_t header structure by giving the string s has second argument to function sip_accept_encoding_make().

The corresponding tag taking reference parameter is SIPTAG_ACCEPT_ENCODING_STR_REF().

## Typedef Documentation

## sip_accept_encoding_t

typedef msg_accept_any_t sip_accept_encoding_t

@

The Accept-Encoding header is similar to Accept, but restricts the content-codings that are acceptable in the response. Its syntax is defined in [H14.3, S10.7] as follows:

Accept-Encoding = "Accept-Encoding" HCOLON
[ encoding *(COMMA encoding) ]
encoding = codings *(SEMI accept-param)
codings = content-coding / "*"
content-coding = token

The parsed Accept-Encoding header is stored in sip_accept_encoding_t structure.

The structure sip_accept_encoding_t contains representation of SIP Accept-Encoding header.

The sip_accept_encoding_t is defined as follows:

typedef struct {
msg_common_t aa_common[1]; // Common fragment info
sip_accept_encoding_t *aa_next; // Pointer to next @AcceptEncoding header
char const *aa_value; // Encoding token
msg_param_t const *aa_params; // List of parameters
char const *aa_q; // Value of q parameter
} sip_accept_encoding_t;
msg_common_t
struct msg_common_s msg_common_t

## Function Documentation

## sip_accept_encoding_copy()

sip_accept_encoding_t * sip_accept_encoding_copy | ( | su_home_t * | home,
|  | sip_accept_encoding_t const * | hdr )

inline

Copy a list of Accept-Encoding header header structures sip_accept_encoding_t.

The function sip_accept_encoding_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  accept_encoding = sip_accept_encoding_copy(home, sip->sip_accept_encoding);
  sip_accept_encoding_copy
  sip_accept_encoding_t * sip_accept_encoding_copy(su_home_t *home, sip_accept_encoding_t const *hdr))
  Copy a list of Accept-Encoding header header structures sip_accept_encoding_t.
  Definition sip_protos.h:7418

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_accept_encoding_dup()

sip_accept_encoding_t * sip_accept_encoding_dup | ( | su_home_t * | home,
|  | sip_accept_encoding_t const * | hdr )

inline

Duplicate a list of Accept-Encoding header header structures sip_accept_encoding_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  accept_encoding = sip_accept_encoding_dup(home, sip->sip_accept_encoding);
  sip_accept_encoding_dup
  sip_accept_encoding_t * sip_accept_encoding_dup(su_home_t *home, sip_accept_encoding_t const *hdr))
  Duplicate a list of Accept-Encoding header header structures sip_accept_encoding_t.
  Definition sip_protos.h:7375

Returns
  A pointer to the newly duplicated sip_accept_encoding_t header structure, or NULL upon an error.

## sip_accept_encoding_format()

sip_accept_encoding_t * sip_accept_encoding_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Accept-Encoding header from formatting result.

Make a new sip_accept_encoding_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_accept_encoding_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_accept_encoding_init()

sip_accept_encoding_t * sip_accept_encoding_init | ( | sip_accept_encoding_t | x[1] | ) |

inline

Initialize a structure sip_accept_encoding_t.

An sip_accept_encoding_t structure for Accept-Encoding header can be initialized with the sip_accept_encoding_init() function/macro. For instance,

sip_accept_encoding_t sip_accept_encoding;
sip_accept_encoding_init(&sip_accept_encoding);
sip_accept_encoding_init
sip_accept_encoding_t * sip_accept_encoding_init(sip_accept_encoding_t x[1])
Initialize a structure sip_accept_encoding_t.
Definition sip_protos.h:7306

## sip_accept_encoding_make()

sip_accept_encoding_t * sip_accept_encoding_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Accept-Encoding header structure sip_accept_encoding_t.

The function sip_accept_encoding_make() makes a new sip_accept_encoding_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_accept_encoding_t header structure, or NULL upon an error.

## sip_is_accept_encoding()

int sip_is_accept_encoding | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_accept_encoding_t.

Check if the header class is an instance of Accept-Encoding header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header accept_encoding
  0 | (false) otherwise

## Variable Documentation

## sip_accept_encoding_class

msg_hclass_t sip_accept_encoding_class[]

extern

Header class for Accept-Encoding header.

The header class sip_accept_encoding_class defines how a SIP Accept-Encoding header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_accept_encoding_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.